import java.sql.SQLException;
import java.sql.Connection;
import oracle.jdbc.OracleTypes;
import oracle.sql.ORAData;
import oracle.sql.ORADataFactory;
import oracle.sql.Datum;
import oracle.sql.ARRAY;
import oracle.sql.ArrayDescriptor;
import oracle.jpub.runtime.MutableArray;

public class PflegtTab implements ORAData, ORADataFactory
{
  public static final String _SQL_NAME = "OBJECT.PFLEGT_TAB";
  public static final int _SQL_TYPECODE = OracleTypes.ARRAY;

  MutableArray _array;

private static final PflegtTab _PflegtTabFactory = new PflegtTab();

  public static ORADataFactory getORADataFactory()
  { return _PflegtTabFactory; }
  /* constructors */
  public PflegtTab()
  {
    this((TierRef[])null);
  }

  public PflegtTab(TierRef[] a)
  {
    _array = new MutableArray(2006, a, TierRef.getORADataFactory());
  }

  /* ORAData interface */
  public Datum toDatum(Connection c) throws SQLException
  {
    return _array.toDatum(c, _SQL_NAME);
  }

  /* ORADataFactory interface */
  public ORAData create(Datum d, int sqlType) throws SQLException
  {
    if (d == null) return null; 
    PflegtTab a = new PflegtTab();
    a._array = new MutableArray(2006, (ARRAY) d, TierRef.getORADataFactory());
    return a;
  }

  public int length() throws SQLException
  {
    return _array.length();
  }

  public int getBaseType() throws SQLException
  {
    return _array.getBaseType();
  }

  public String getBaseTypeName() throws SQLException
  {
    return _array.getBaseTypeName();
  }

  public ArrayDescriptor getDescriptor() throws SQLException
  {
    return _array.getDescriptor();
  }

  /* array accessor methods */
  public TierRef[] getArray() throws SQLException
  {
    return (TierRef[]) _array.getObjectArray(
      new TierRef[_array.length()]);
  }

  public TierRef[] getArray(long index, int count) throws SQLException
  {
    return (TierRef[]) _array.getObjectArray(index,
      new TierRef[_array.sliceLength(index, count)]);
  }

  public void setArray(TierRef[] a) throws SQLException
  {
    _array.setObjectArray(a);
  }

  public void setArray(TierRef[] a, long index) throws SQLException
  {
    _array.setObjectArray(a, index);
  }

  public TierRef getElement(long index) throws SQLException
  {
    return (TierRef) _array.getObjectElement(index);
  }

  public void setElement(TierRef a, long index) throws SQLException
  {
    _array.setObjectElement(a, index);
  }

}
